/**
 * Spring, Hibernate y modelos anémicos
 * Copyright 2010 Autentia Real Business Solutions S.L.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.autentia.tutorial.modelos.anemicos;

import javax.inject.Inject;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;

import org.springframework.beans.factory.annotation.Configurable;

@Entity
@Configurable(preConstruction = true)
class DomainObject {

	@Id
	@GeneratedValue
	private Long id;

	@Inject
	@Transient
	private ServiceToInject injectedDependendy;

	private final String name;

	DomainObject(String name) {
		System.out.println("Creando una instancia de " + getClass().getSimpleName() + " (" + injectedDependendy + ")");
		this.name = name;
	}

	Long getId() {
		return id;
	}

	Object getInjectedDependency() {
		return injectedDependendy;
	}

	String getName() {
		return name;
	}
}
